<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::json::jsonUtils Namespace Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json.html">json</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html">jsonUtils</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::json::jsonUtils Namespace Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ab88d7709c7c0976c6547b92083e544dd"><td class="memItemLeft" align="right" valign="top">static std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#ab88d7709c7c0976c6547b92083e544dd">getTag</a> ()</td></tr>
<tr class="separator:ab88d7709c7c0976c6547b92083e544dd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5fbef19f32e81db50d918cc3c2b5bcda"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#a5fbef19f32e81db50d918cc3c2b5bcda">findNode</a> (const rapidjson::Value &amp;jsonNode, const std::string &amp;key, rapidjson::Value::ConstMemberIterator *iteratorPtr)</td></tr>
<tr class="separator:a5fbef19f32e81db50d918cc3c2b5bcda"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c3445572979f4dca168edabf10c17ea"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#a9c3445572979f4dca168edabf10c17ea">parseJSON</a> (const std::string &amp;jsonContent, rapidjson::Document *document)</td></tr>
<tr class="separator:a9c3445572979f4dca168edabf10c17ea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa97f53eadfa124bb8797e1325b4dbe52"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#aa97f53eadfa124bb8797e1325b4dbe52">convertToValue</a> (const rapidjson::Value &amp;documentNode, std::string *value)</td></tr>
<tr class="separator:aa97f53eadfa124bb8797e1325b4dbe52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ab6c031209d9171aa85512fe7033ef1"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#a3ab6c031209d9171aa85512fe7033ef1">convertToValue</a> (const rapidjson::Value &amp;documentNode, int64_t *value)</td></tr>
<tr class="separator:a3ab6c031209d9171aa85512fe7033ef1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a412fc3128b7a5ed2dc7fe6f4bc721d1e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#a412fc3128b7a5ed2dc7fe6f4bc721d1e">convertToValue</a> (const rapidjson::Value &amp;documentNode, uint64_t *value)</td></tr>
<tr class="separator:a412fc3128b7a5ed2dc7fe6f4bc721d1e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5847e7c123fda65a6a95c3bf3e97999"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#aa5847e7c123fda65a6a95c3bf3e97999">convertToValue</a> (const rapidjson::Value &amp;documentNode, bool *value)</td></tr>
<tr class="separator:aa5847e7c123fda65a6a95c3bf3e97999"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8fee520868204e654e46ccc3887651d"><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr class="memitem:af8fee520868204e654e46ccc3887651d"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#af8fee520868204e654e46ccc3887651d">retrieveValue</a> (const rapidjson::Value &amp;jsonNode, const std::string &amp;key, T *value)</td></tr>
<tr class="separator:af8fee520868204e654e46ccc3887651d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada99fd6893bc7cc654815944eade108c"><td class="memTemplParams" colspan="2">template&lt;typename T &gt; </td></tr>
<tr class="memitem:ada99fd6893bc7cc654815944eade108c"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#ada99fd6893bc7cc654815944eade108c">retrieveValue</a> (const std::string jsonString, const std::string &amp;key, T *value)</td></tr>
<tr class="separator:ada99fd6893bc7cc654815944eade108c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a64a4d58e058d6eeed808fed28bda5ef9"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#a64a4d58e058d6eeed808fed28bda5ef9">jsonArrayExists</a> (const rapidjson::Value &amp;parsedDocument, const std::string &amp;key)</td></tr>
<tr class="separator:a64a4d58e058d6eeed808fed28bda5ef9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac0c3df60158ce08a7c25913cdb797c5a"><td class="memItemLeft" align="right" valign="top">static const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#ac0c3df60158ce08a7c25913cdb797c5a">TAG</a> (&quot;JsonUtils&quot;)</td></tr>
<tr class="memdesc:ac0c3df60158ce08a7c25913cdb797c5a"><td class="mdescLeft">&#160;</td><td class="mdescRight">String to identify log entries originating from this file.  <a href="#ac0c3df60158ce08a7c25913cdb797c5a">More...</a><br /></td></tr>
<tr class="separator:ac0c3df60158ce08a7c25913cdb797c5a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a897d15d66f540d6a324462f98ddbcdee"><td class="memItemLeft" align="right" valign="top">static std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#a897d15d66f540d6a324462f98ddbcdee">operator&lt;&lt;</a> (std::ostream &amp;stream, rapidjson::Type type)</td></tr>
<tr class="separator:a897d15d66f540d6a324462f98ddbcdee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aeb052b363b2c54c58443c769898eb38e"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1json_1_1json_utils.html#aeb052b363b2c54c58443c769898eb38e">serializeJSONObjectToString</a> (const rapidjson::Value &amp;documentNode, std::string *value)</td></tr>
<tr class="separator:aeb052b363b2c54c58443c769898eb38e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Function Documentation</h2>
<a id="aa97f53eadfa124bb8797e1325b4dbe52"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa97f53eadfa124bb8797e1325b4dbe52">&#9670;&nbsp;</a></span>convertToValue() <span class="overload">[1/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::convertToValue </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>documentNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Converts a given rapidjson document node to a string. The node must be either of Object or String type.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">documentNode</td><td>A logical node within a parsed JSON document which rapidjson understands. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The output parameter which will be assigned the string value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the node was converted to a string ok, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="a3ab6c031209d9171aa85512fe7033ef1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ab6c031209d9171aa85512fe7033ef1">&#9670;&nbsp;</a></span>convertToValue() <span class="overload">[2/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::convertToValue </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>documentNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int64_t *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Converts a given rapidjson value node to a 64-bit signed integer. The node must be Int64 type.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">documentNode</td><td>A logical node within a parsed JSON document which rapidjson understands. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The output parameter which will be assigned the int64_t value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the node was successfully converted, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="a412fc3128b7a5ed2dc7fe6f4bc721d1e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a412fc3128b7a5ed2dc7fe6f4bc721d1e">&#9670;&nbsp;</a></span>convertToValue() <span class="overload">[3/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::convertToValue </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>documentNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint64_t *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Converts a given rapidjson value node to a 64-bit unsigned integer. The node must be unsigned int type.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">documentNode</td><td>A logical node within a parsed JSON document which rapidjson understands. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The output parameter which will be assigned the unsigned int value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the node was successfully converted, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="aa5847e7c123fda65a6a95c3bf3e97999"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5847e7c123fda65a6a95c3bf3e97999">&#9670;&nbsp;</a></span>convertToValue() <span class="overload">[4/4]</span></h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::convertToValue </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>documentNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Converts a given rapidjson value node to a bool. The node must be Bool type.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">documentNode</td><td>A logical node within a parsed JSON document which rapidjson understands. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The output parameter which will be assigned the bool value. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the node was successfully converted, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="a5fbef19f32e81db50d918cc3c2b5bcda"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5fbef19f32e81db50d918cc3c2b5bcda">&#9670;&nbsp;</a></span>findNode()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::findNode </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>jsonNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rapidjson::Value::ConstMemberIterator *&#160;</td>
          <td class="paramname"><em>iteratorPtr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Give a <code>rapidjson::Value</code> object, this function will find a direct child node that matches the <code>key</code>. Copy constructors are hidden for <code>rapidjson::Value</code> objects, so iterators are used to retrieve the value of the node.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">jsonNode</td><td>The JSON node object. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">key</td><td>The key of the underlying JSON content we wish to acquire the value of. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">iteratorPtr</td><td>A pointer to a <code>ConstMemberIterator</code>, which will contain the <code>Value</code>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if the lookup is successful, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="ab88d7709c7c0976c6547b92083e544dd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab88d7709c7c0976c6547b92083e544dd">&#9670;&nbsp;</a></span>getTag()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::string alexaClientSDK::avsCommon::utils::json::jsonUtils::getTag </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Returns the tag for logging purposes. </p>

</div>
</div>
<a id="a64a4d58e058d6eeed808fed28bda5ef9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a64a4d58e058d6eeed808fed28bda5ef9">&#9670;&nbsp;</a></span>jsonArrayExists()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::jsonArrayExists </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>parsedDocument</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Queries whether an array object exists as a child of a pre-parsed rapidjson::Value element.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">parsedDocument</td><td>The Value within which the array should be looked for. </td></tr>
    <tr><td class="paramname">key</td><td>The name of the array being looked for. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether a child element of array type was found. </dd></dl>

</div>
</div>
<a id="a897d15d66f540d6a324462f98ddbcdee"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a897d15d66f540d6a324462f98ddbcdee">&#9670;&nbsp;</a></span>operator&lt;&lt;()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static std::ostream&amp; alexaClientSDK::avsCommon::utils::json::jsonUtils::operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>stream</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rapidjson::Type&#160;</td>
          <td class="paramname"><em>type</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Write a <code>rapidjson::Type</code> value to an <code>ostream</code> as a string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">stream</td><td>The stream to write the value to. </td></tr>
    <tr><td class="paramname">type</td><td>The type value to write to the <code>ostream</code> as a string. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The <code>ostream</code> that was passed in and written to. </dd></dl>

</div>
</div>
<a id="a9c3445572979f4dca168edabf10c17ea"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9c3445572979f4dca168edabf10c17ea">&#9670;&nbsp;</a></span>parseJSON()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::parseJSON </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>jsonContent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">rapidjson::Document *&#160;</td>
          <td class="paramname"><em>document</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Invoke a rapidjson parse on a JSON string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">jsonContent</td><td>The JSON content to be parsed. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">document</td><td>The output parameter rapidjson document. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the JSON content was valid, <code>false</code> otherwise.</dd></dl>
<p>Invoke a rapidjson parse a on JSON string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">jsonContent</td><td>The JSON content to be parsed. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">document</td><td>The output parameter rapidjson document. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the JSON content was valid, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="af8fee520868204e654e46ccc3887651d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af8fee520868204e654e46ccc3887651d">&#9670;&nbsp;</a></span>retrieveValue() <span class="overload">[1/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::retrieveValue </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>jsonNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">A template function to find and retrieve a value of type T from a direct child of the provided <code>rapidjson::Value</code> object. The type T must have an overload of the function <code>convertToValue</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">jsonNode</td><td>A logical node within a parsed JSON document which rapidjson understands. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">key</td><td>The key in which to look for the value. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The output parameter which will be assigned the value of type T if the function succeeds. No modification is done in case of failure. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the value was successfully retrieved, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="ada99fd6893bc7cc654815944eade108c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ada99fd6893bc7cc654815944eade108c">&#9670;&nbsp;</a></span>retrieveValue() <span class="overload">[2/2]</span></h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::json::jsonUtils::retrieveValue </td>
          <td>(</td>
          <td class="paramtype">const std::string&#160;</td>
          <td class="paramname"><em>jsonString</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">A template function to find and retrieve a value of type T from the provided JSON string. The provided string will first be parsed into a JSON document, after which the associated value T will be retrieved. The type T must have an overload of the function <code>convertToValue</code>.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">jsonString</td><td>A JSON string. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">key</td><td>The key in which to look for the value. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The output parameter which will be assigned the value of type T if the function succeeds. No modification is done in case of failure. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the value was successfully retrieved, <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="aeb052b363b2c54c58443c769898eb38e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeb052b363b2c54c58443c769898eb38e">&#9670;&nbsp;</a></span>serializeJSONObjectToString()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static void alexaClientSDK::avsCommon::utils::json::jsonUtils::serializeJSONObjectToString </td>
          <td>(</td>
          <td class="paramtype">const rapidjson::Value &amp;&#160;</td>
          <td class="paramname"><em>documentNode</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string *&#160;</td>
          <td class="paramname"><em>value</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Serialize a rapidjson document node, which must be of Object type, into a string.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">documentNode</td><td>A logical node within a parsed JSON document which rapidjson understands. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">value</td><td>The output parameter where the converted string will be assigned. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac0c3df60158ce08a7c25913cdb797c5a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac0c3df60158ce08a7c25913cdb797c5a">&#9670;&nbsp;</a></span>TAG()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static const std::string alexaClientSDK::avsCommon::utils::json::jsonUtils::TAG </td>
          <td>(</td>
          <td class="paramtype">&quot;JsonUtils&quot;&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>String to identify log entries originating from this file. </p>

</div>
</div>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
